// NewServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "ServerWnd.h"
#include "NewServerDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CNewServerDlg dialog

IMPLEMENT_DYNAMIC(CNewServerDlg, CDialog)
CNewServerDlg::CNewServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNewServerDlg::IDD, pParent)
	, m_strServerAddr(_T(""))
	, m_strPort(_T("4661"))
	, m_strServerName(_T(""))
{
	m_cpPosition.x = 0;
	m_cpPosition.y = 0;
	
	m_iCorner = 0;	// top-left

	m_bUsePos = false;

	m_pParent = NULL;
}

CNewServerDlg::~CNewServerDlg()
{
}

void CNewServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_IPADDRESS, m_strServerAddr);
	DDX_Text(pDX, IDC_SPORT, m_strPort);
	DDX_Text(pDX, IDC_SNAME, m_strServerName);
}


BEGIN_MESSAGE_MAP(CNewServerDlg, CDialog)
	ON_BN_CLICKED(IDC_ADDSERVER, OnBnClickedAddserver)
END_MESSAGE_MAP()


// CNewServerDlg message handlers

BOOL CNewServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	if(m_bUsePos)
	{
		CRect rWnd;
		GetWindowRect(rWnd);
		
		switch(m_iCorner)
		{
			case 0: // top-left
				SetWindowPos(NULL, m_cpPosition.x, m_cpPosition.y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
				break;
			case 1:	// top-right
				SetWindowPos(NULL, m_cpPosition.x - rWnd.Width(), m_cpPosition.y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
				break;
			case 2: // bottom-right
				SetWindowPos(NULL, m_cpPosition.x - rWnd.Width(), m_cpPosition.y - rWnd.Height(), 0, 0, SWP_NOZORDER | SWP_NOSIZE);
				break;
			case 3: // bottom-left
				SetWindowPos(NULL, m_cpPosition.x, m_cpPosition.y - rWnd.Height(), 0, 0, SWP_NOZORDER | SWP_NOSIZE);
				break;
			default:
				break;
		}
	}
	Localize();
	UpdateData(false);
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CNewServerDlg::SetInitialPos(CPoint pos, int iCorner)
{
	m_iCorner = iCorner;
	m_cpPosition = pos;
	m_bUsePos = true;
}

void CNewServerDlg::OnBnClickedAddserver()
{
	UpdateData();
	if(!m_pParent)
		return;

	m_pParent->AddServer(m_strServerAddr, m_strPort, m_strServerName);
	EndDialog(0x00);
}

void CNewServerDlg::SetParent(CServerWnd* pParent)
{
	m_pParent = pParent;
}

void CNewServerDlg::Localize()
{
	if(m_hWnd)
	{		
		SetWindowText(GetResString(IDS_SV_NEWSERVER));
		GetDlgItem(IDC_IPADDRESS_LBL)->SetWindowText(GetResString(IDS_SV_ADDRESS));
		GetDlgItem(IDC_PORT_LBL)->SetWindowText(GetResString(IDS_SV_PORT));
		GetDlgItem(IDC_NAME_LBL)->SetWindowText(GetResString(IDS_SW_NAME));
		GetDlgItem(IDC_ADDSERVER)->SetWindowText(GetResString(IDS_SV_ADD));
	}
}

void CNewServerDlg::OnOK()
{
	OnBnClickedAddserver();
}
