// PPgServer.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgServer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CPPgServer dialog

IMPLEMENT_DYNAMIC(CPPgServer, CPropertyPage)
CPPgServer::CPPgServer()
	: CPropertyPage(CPPgServer::IDD)
	, removeDead(FALSE)
	, autoServer(FALSE)
	, safeConnect(FALSE)
	, smartId(FALSE)
	, updateServerConnect(FALSE)
	, filter(FALSE)
	, filterServersByIP(FALSE)
	, autoConnect(FALSE)
	, autoConnectStatic(FALSE)
	, reconnect(FALSE)
	, scoreSystem(FALSE)
	, manualServerHighPriority(FALSE)
	, serverConnectTimeout(_T(""))
	, serverRetries(_T(""))
	, restartWaiting(FALSE)
	, serverConTimeoutDesc(_T(""))
	, srvSecDesc(_T(""))
	, retriesDesc(_T(""))
{
}

CPPgServer::~CPPgServer()
{
}

void CPPgServer::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_REMOVEDEAD, removeDead);
	DDX_Check(pDX, IDC_AUTOSERVER, autoServer);
	DDX_Check(pDX, IDC_SAFECONNECT, safeConnect);
	DDX_Check(pDX, IDC_SMARTIDCHECK, smartId);
	DDX_Check(pDX, IDC_UPDATESERVERCONNECT, updateServerConnect);
	DDX_Check(pDX, IDC_FILTER, filter);
	DDX_Check(pDX, IDC_FILTERSERVERSBYIP, filterServersByIP);
	DDX_Check(pDX, IDC_RESTARTWAITING, restartWaiting);
	DDX_Check(pDX, IDC_AUTOCONNECT, autoConnect);
	DDX_Check(pDX, IDC_AUTOCONNECTSTATICONLY, autoConnectStatic);
	DDX_Check(pDX, IDC_RECONN, reconnect);
	DDX_Check(pDX, IDC_SCORE, scoreSystem);
	DDX_Check(pDX, IDC_MANUALSERVERHIGHPRIO, manualServerHighPriority);
	DDX_Text(pDX, IDC_SRVCONTIMEOUT, serverConnectTimeout);
	DDX_Text(pDX, IDC_SERVERRETRIES, serverRetries);	
	DDX_Control(pDX, IDC_SERVERRETRIES, serverRetriesEdit);
	DDX_Text(pDX, IDC_SRVCONTIMEOUT_LBL, serverConTimeoutDesc);
	DDX_Text(pDX, IDC_SRV_SEC, srvSecDesc);
	DDX_Control(pDX, IDC_REMOVEDEAD, removeDeadCheck);
	DDX_Text(pDX, IDC_RETRIES_LBL, retriesDesc);
	DDX_Control(pDX, IDC_AUTOSERVER, autoServerCheck);
	DDX_Control(pDX, IDC_SAFECONNECT, safeConnectCheck);
	DDX_Control(pDX, IDC_SMARTIDCHECK, smartIdCheck);
	DDX_Control(pDX, IDC_SCORE, scoreCheck);
	DDX_Control(pDX, IDC_RESTARTWAITING, restartWaitingCheck);
	DDX_Control(pDX, IDC_AUTOCONNECT, autoConnectCheck);
	DDX_Control(pDX, IDC_UPDATESERVERCONNECT, updateServerConnectCheck);
	DDX_Control(pDX, IDC_FILTERSERVERSBYIP, filterServersByIPCheck);
	DDX_Control(pDX, IDC_FILTER, filterCheck);
	DDX_Control(pDX, IDC_RECONN, reconnCheck);
	DDX_Control(pDX, IDC_MANUALSERVERHIGHPRIO, manualSrvHighCheck);
	DDX_Control(pDX, IDC_AUTOCONNECTSTATICONLY, autoConnectStaticCheck);
}


BEGIN_MESSAGE_MAP(CPPgServer, CPropertyPage)
	ON_EN_CHANGE(IDC_SRVCONTIMEOUT, OnEnChangeSrvConTimeout)
	ON_EN_CHANGE(IDC_SERVERRETRIES, OnEnChangeServerretries)
	ON_BN_CLICKED(IDC_AUTOSERVER, OnBnClickedAutoserver)
	ON_BN_CLICKED(IDC_UPDATESERVERCONNECT, OnBnClickedUpdateserverconnect)
	ON_BN_CLICKED(IDC_FILTER, OnBnClickedFilter)
	ON_BN_CLICKED(IDC_SCORE, OnBnClickedScore)
	ON_BN_CLICKED(IDC_REMOVEDEAD, OnBnClickedRemovedead)
	ON_BN_CLICKED(IDC_RESTARTWAITING, OnBnClickedRestartWaiting)
	ON_BN_CLICKED(IDC_SAFECONNECT, OnBnClickedFastConnect)
	ON_BN_CLICKED(IDC_SMARTIDCHECK, OnBnClickedSmartIdCheck)
	ON_BN_CLICKED(IDC_AUTOCONNECT, OnBnClickedAutoconnect)
	ON_BN_CLICKED(IDC_RECONN, OnBnClickedReconn)
	ON_BN_CLICKED(IDC_AUTOCONNECTSTATICONLY, OnBnClickedStaticOnly)
	ON_BN_CLICKED(IDC_MANUALSERVERHIGHPRIO, OnBnClickedManualHighPrio)
	ON_BN_CLICKED(IDC_FILTERSERVERSBYIP , OnBnClickedFilterServersByIP)
END_MESSAGE_MAP()


// CPPgServer message handlers

BOOL CPPgServer::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPPgServer::LoadSettings(void)
{
	serverConnectTimeout.Format(_T("%d"), app_prefs->SrvConTimeout()/1000);		//Cax2 - bugfix for time out - ticks are in milliseconds!!!!!
	serverRetries.Format(_T("%d"), app_prefs->GetDeadserverRetries());

	safeConnect = app_prefs->IsSafeConnectEnabled();
	manualServerHighPriority = app_prefs->GetManualHighPrio();
	smartId = app_prefs->GetSmartIdCheck();
	removeDead = app_prefs->DeadServer();			
	autoServer = app_prefs->AutoServerlist();
	updateServerConnect = app_prefs->GetAddServersFromConn();
	filter = app_prefs->FilterBadIPs();
	filterServersByIP = app_prefs->FilterServersByIP();
	scoreSystem = app_prefs->Score();
	restartWaiting = app_prefs->RestartWaiting();
	reconnect = app_prefs->Reconnect();
	autoConnect = app_prefs->DoAutoConnect();
	// Barry
	autoConnectStatic = app_prefs->AutoConnectStaticOnly();
	
	UpdateData(FALSE);
	OnBnClickedRemovedead();
	SetModified(FALSE);	// FoRcHa
}

BOOL CPPgServer::OnApply()
{	
	if(m_bModified)
	{
		UpdateData(TRUE);	
		
		app_prefs->SetDeadServer(removeDead);		
		app_prefs->SetSafeConnectEnabled(safeConnect);		
		app_prefs->SetSmartIdCheck(smartId);
	
		int sct = _tstoi(serverConnectTimeout);
		if (sct < 10)
			sct = 10;
		else if(sct > 60)
			sct = 60;

		app_prefs->SetSrvConTimeout(sct*1000);		//Cax2 - bugfix for time out - ticks are in milliseconds!!!!!
		serverConnectTimeout.Format(_T("%d"),app_prefs->SrvConTimeout()/1000);
		
		if(!serverRetries.IsEmpty())
		{
			int sr = _tstoi(serverRetries);
			if (sr == 0)
				sr = 5;
			app_prefs->SetDeadserverRetries(sr);
		}
		if(app_prefs->GetDeadserverRetries() < 1) 
			app_prefs->SetDeadserverRetries(5);
	
		app_prefs->SetScore(scoreSystem);
		app_prefs->SetAutoServerlist(autoServer);
		app_prefs->SetAddServersFromConn(updateServerConnect);
		app_prefs->SetFilterBadIPs(filter);
		app_prefs->SetFilterServersByIP(filterServersByIP);
		app_prefs->SetRestartWaiting(restartWaiting);
	
		app_prefs->SetAutoConnect(autoConnect);
		app_prefs->SetReconnect(reconnect);
		app_prefs->SetManualHighPrio(manualServerHighPriority);

		// Barry
		app_prefs->SetAutoConnectStaticOnly(autoConnectStatic);

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgServer::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_SERVER));
		
		serverConTimeoutDesc = GetResString(IDS_SRVCONTIMEOUT_LBL);
		srvSecDesc = GetResString(IDS_SECS);
		removeDeadCheck.SetWindowText(GetResString(IDS_PW_RDEAD));
		retriesDesc = GetResString(IDS_PW_RETRIES);
		
		updateServerConnectCheck.SetWindowText(GetResString(IDS_PW_USC));		
		filterCheck.SetWindowText(GetResString(IDS_PW_FILTER));
		filterServersByIPCheck.SetWindowText(GetResString(IDS_FILTERSERVERSBYIP));
		autoServerCheck.SetWindowText(GetResString(IDS_PW_USS));
		
		scoreCheck.SetWindowText(GetResString(IDS_PW_SCORE));		
		restartWaitingCheck.SetWindowText(GetResString(IDS_RESTARTWAITING));	
		smartIdCheck.SetWindowText(GetResString(IDS_SMARTLOWIDCHECK));
		safeConnectCheck.SetWindowText(GetResString(IDS_PW_FASTSRVCON));

		autoConnectCheck.SetWindowText(GetResString(IDS_PW_AUTOCON));
		reconnCheck.SetWindowText(GetResString(IDS_PW_RECON));
		manualSrvHighCheck.SetWindowText(GetResString(IDS_MANUALSERVERHIGHPRIO));		
		autoConnectStaticCheck.SetWindowText(GetResString(IDS_PW_AUTOCONNECTSTATICONLY));
		UpdateData(FALSE);
	}
}

void CPPgServer::OnBnClickedRemovedead()
{
	UpdateData(TRUE);
	serverRetriesEdit.EnableWindow(removeDead);

	SetModified();
}
