//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
#include <sys/timeb.h>
#include "types.h"
#include "titlemenu.h"
#include "MuleListCtrl.h"
#include "Loggable.h"

#ifndef USRMSG_SWITCHUPLOADLIST
#define USRMSG_SWITCHUPLOADLIST	WM_USER + 12
#endif

// CQueueListCtrl
class CUpDownClient;

class CQueueListCtrl : public CMuleListCtrl, public CLoggable
{
	DECLARE_DYNAMIC(CQueueListCtrl)

public:
	CQueueListCtrl();
	virtual ~CQueueListCtrl();
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	void	Init();
	void	AddClient(CUpDownClient* client, bool reset = true);
	void	RemoveClient(CUpDownClient* client);
	void	RefreshClient(CUpDownClient* client);
	void	Hide() {ShowWindow(SW_HIDE);}
	void	Visable() {ShowWindow(SW_SHOW);}
	void	SortInit(int sortCode);	//sortdlg Cax2
	DWORD	m_sortTime; //sortdlg Cax2
	void	Localize();

	virtual BOOL OnCommand(WPARAM wParam,LPARAM lParam );
protected:
	static int CALLBACK SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
	afx_msg	void OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	DECLARE_MESSAGE_MAP()
private:
	bool		 asc_sort[13];	 
	CImageList imagelist;
	CTitleMenu	   m_ClientMenu;
	// Barry - Refresh the queue every X seconds
	UINT_PTR m_hTimer;
	static void CALLBACK QueueUpdateTimer(HWND hwnd, UINT uiMsg, UINT idEvent, DWORD dwTime);
public:
	afx_msg void OnNMClick(NMHDR *pNMHDR, LRESULT *pResult);
	/**AK start**/
	afx_msg void OnNMDblclkQueuelist(NMHDR *pNMHDR, LRESULT *pResult);
	/**AK finish**/
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	void RefreshInfo(void);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	virtual BOOL OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult);
};


