//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#pragma once
#include "sharedfilelist.h"
#include "knownfile.h"
#include "types.h"
#include "MuleListCtrl.h"
#include "ShellContextMenu.h"

//--- xrmb:parttraffic ---
//--- its for "better" sorting ---
#include "listControlSorter.h"
#include "Loggable.h"

//--- we have two different items ---
class	sfl_itemdata
{
public:
	//sfl_itemdata() : knownFile(NULL), repaintBar(true), updated(0) {}
	//~sfl_itemdata() { bar.DeleteObject(); }

	bool		isFile;
	bool		isOpen;
	uint16		part;
	uint16		parts;
	CKnownFile	*knownFile;

	//uint32	updated;
	//bool		repaintBar;
	//CBitmap     	bar;
};
//--- :xrmb ---

// CSharedFilesCtrl
class CSharedFileList;
class CSharedFilesCtrl : public CMuleListCtrl, public CLoggable
{
	DECLARE_DYNAMIC(CSharedFilesCtrl)

public:
	CSharedFilesCtrl();
	virtual ~CSharedFilesCtrl();
	void	Init();
	void	ShowFileList(CSharedFileList* in_sflist);
	//--- xrmb:parttraffic ---
	void	ShowFile(CKnownFile* file, bool resort=true);
	void	ShowFile(CKnownFile* file, uint32 itemnr, bool resort=true);
	//--- :xrmb ---
	void	RemoveFile(CKnownFile* toremove);
	//--- xrmb:parttraffic ---
	void	UpdateFile(CKnownFile* file, uint32 pos, bool resort=true);
	void	UpdateItem(CKnownFile* toupdate, bool resort=true);
	//--- :xrmb ---
	void	SortInit(int sortCode);	//sortdlg Cax2
	void	Localize();
	void	ShowFilesCount();
	//--- xrmb:parttraffic ---
	void	SetColoring(uint8 mode);
	void	SetDisplay(uint8 mode, bool redraw);
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	virtual BOOL DeleteAllItems();
	//--- :xrmb ---

protected:
	static int CALLBACK SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
	afx_msg	void OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult);
	//--- xrmb:parttraffic ---
	afx_msg	void OnDoubleClick(NMHDR* pNMHDR, LRESULT* pResult);
	//--- :xrmb ---
	DECLARE_MESSAGE_MAP()
private:
	//--- xrmb:parttraffic ---
	//CSharedFileList* sflist;	//no used
	bool			DrawStatusBarFile(CDC* dc, RECT* rect, const CFileStatistic& statistic);
	bool			DrawStatusBarPart(CDC* dc, RECT* rect, const CFileStatistic& statistic, uint16 part);

	//--- dont need it anymore ---
	//CTitleMenu	m_SharedFilesMenu;
	//CMenu		   	m_PrioMenu;
	//CMenu		   	m_PermMenu;

	CListCtrlSorter		m_listSorter;
	static	bool		m_sortParts;
	COLORREF(*GetTrafficColor)(float);// yes kids, thats a function pointer :)
	uint8			m_display;
	uint8			m_display_atpts;
	uint8			m_display_atpte;
	uint8			m_display_atbts;
	uint8			m_display_atbte;
	uint8			m_display_sbts;
	uint8			m_display_sbte;

	void	TraffiGram(CDC* dc, RECT* rect, const CFileStatistic& statistic, int use, double bpp, uint32 start=0);
	bool	m_trafficgram;

	//--- for fast prio-sorting ---
	static	uint8	m_p2p[8];	//eklmn: extra place for new priority JUMPSTART,...

	//--- make it win9x compatible by using only one bitmap, brush...? ---
	CDC		cdcStatus; 
	CPen	pen;
	CBrush	brush;
	CBitmap status;

	int		m_statusWidth;
	//--- :xrmb ---

	//--- xrmb:allyaknow ---
	//--- for the gone files ---
	bool	m_allYaKnow;
	void	ShowKnownList();
	//--- :xrmb ---
	CShellContextMenu *m_pSCM;

public:
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
};

//--- xrmb:parttraffic ---
COLORREF	GetTrafficColor0(float f);	/// rainbow (exp)
COLORREF	GetTrafficColor1(float f);	/// rainbow (lin)
COLORREF	GetTrafficColor2(float f);	/// blue
COLORREF	GetTrafficColor3(float f);	/// pink
//--- :xrmb ---
