//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// UploadListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "UploadListCtrl.h"
#include "otherfunctions.h"
#include "opcodes.h"
#include "ClientDetailDialog.h"
#include "memcpy_amd.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CUploadListCtrl

IMPLEMENT_DYNAMIC(CUploadListCtrl, CMuleListCtrl)
CUploadListCtrl::CUploadListCtrl(){
	memset(&asc_sort, 0, sizeof(asc_sort)); // i_a 
}

void CUploadListCtrl::Init()
{
	EMULE_TRY

	SetExtendedStyle(LVS_EX_FULLROWSELECT);
	InsertColumn(0,GetResString(IDS_QL_USERNAME),LVCFMT_LEFT,150,0);
	InsertColumn(1,GetResString(IDS_FILE),LVCFMT_LEFT,275,1);
	InsertColumn(2,GetResString(IDS_DL_SPEED),LVCFMT_LEFT,60,2);
	InsertColumn(3,GetResString(IDS_DL_TRANSF),LVCFMT_LEFT,65,3);
	InsertColumn(4,GetResString(IDS_WAITED),LVCFMT_LEFT,60,4);
	InsertColumn(5,GetResString(IDS_UPLOADTIME),LVCFMT_LEFT,60,5);
	InsertColumn(6,GetResString(IDS_STATUS),LVCFMT_LEFT,110,6);
	InsertColumn(7,GetResString(IDS_UP_PARTS),LVCFMT_LEFT,60,7);
	InsertColumn(8,GetResString(IDS_DL_PROGRESS),LVCFMT_LEFT,110,8);
	InsertColumn(9,GetResString(IDS_COMPRESSION),LVCFMT_LEFT,110,9); // Add show compression	//netwolf 05.05.03 (left justified)

	imagelist.Create(16,16,ILC_COLOR32|ILC_MASK,0,10);
	imagelist.SetBkColor(CLR_NONE);
	imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_NORMAL),16,16));			// 0
	imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_COMPROT),16,16));			// 1
	imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_MLDONKEY),16,16));			// 2
    imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_EDONKEYHYBRID),16,16));  	// 3
    imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_CREDIT_ONLY),16,16));      // 4
    imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_FRIEND_ONLY),16,16));      // 5
    imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_BANNED_ONLY),16,16));      // 6
    imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_26_ONLY),16,16));         	// 7
    imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_UNKNOWN),16,16));  		// 8
    imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_CDONKEY),16,16));  		// 9
    imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_LMULE),16,16));  			// 10
    imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SHAREAZA),16,16));  		// 11


    LoadImgLstIcon(NULL,0,0); // delete temp-icon
	SetImageList(&imagelist,LVSIL_SMALL);

	LoadSettings(CPreferences::tableUpload);
	if (theApp.glob_prefs->DoUseSort()) SortInit(theApp.glob_prefs->GetUploadSortCol());
	else {
		// Barry - Use preferred sort order from preferences
		int sortItem = theApp.glob_prefs->GetColumnSortItem(CPreferences::tableUpload);
		bool sortAscending = theApp.glob_prefs->GetColumnSortAscending(CPreferences::tableUpload);
		SetSortArrow(sortItem, sortAscending);
		SortItems(SortProc, sortItem + (sortAscending ? 0:10));
	}

	EMULE_CATCH2
}

CUploadListCtrl::~CUploadListCtrl(){
	imagelist.DeleteImageList();	//eklmn: bugfix(01): resource cleanup due to ImageLists recreation
}

void CUploadListCtrl::SortInit(int sortCode)	//Cax2 sortdlg
{
	EMULE_TRY

	int m_CurrentSortItem=(sortCode<10)?sortCode:sortCode-10;
	SetSortArrow(m_CurrentSortItem,(sortCode<10));
	SortItems(&SortProc, sortCode);

	EMULE_CATCH2
}

void CUploadListCtrl::Localize() 
{
	EMULE_TRY

	if(GetSafeHwnd())
	{
		CHeaderCtrl* pHeaderCtrl = GetHeaderCtrl();
		HDITEM hdi;
		hdi.mask = HDI_TEXT;
		CString strRes;

		strRes = GetResString(IDS_QL_USERNAME);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(0, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_FILE);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(1, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_SPEED);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(2, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_TRANSF);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(3, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_WAITED);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(4, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_UPLOADTIME);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(5, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_STATUS);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(6, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_UP_PARTS);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(7, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_PROGRESS);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(8, &hdi);
		strRes.ReleaseBuffer();

	    strRes = GetResString(IDS_COMPRESSION);
	    hdi.pszText = strRes.GetBuffer();
	    pHeaderCtrl->SetItem(9, &hdi);
	    strRes.ReleaseBuffer();
	}

	EMULE_CATCH
}

void CUploadListCtrl::AddClient(CUpDownClient* client){
	EMULE_TRY

	uint32 itemnr = GetItemCount();
	itemnr = InsertItem(LVIF_TEXT|LVIF_PARAM,itemnr,0,0,0,1,(LPARAM)client);
	RefreshClient(client);

	EMULE_CATCH
}

void CUploadListCtrl::RemoveClient(CUpDownClient* client){
	EMULE_TRY

	if(theApp.emuledlg->transferwnd.infolistctrl.GetType() == 1)
	{
		if(theApp.emuledlg->transferwnd.infolistctrl.GetClient() == client)
		{
			theApp.emuledlg->transferwnd.infolistctrl.SwitchToFile(NULL);
			theApp.emuledlg->transferwnd.UpdateInfoHeader();
		}
	}
	
	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)client;
	sint32 result = FindItem(&find);
	if (result != (-1) )
		DeleteItem(result);

	EMULE_CATCH
}

void CUploadListCtrl::RefreshClient(CUpDownClient* client)
{
	EMULE_TRY

	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)client;
	sint16 result = FindItem(&find);
	if(result != -1)
		Update(result);
	return;

    EMULE_CATCH
}

#define DLC_DT_TEXT (DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX|DT_END_ELLIPSIS)

void CUploadListCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct){
	EMULE_TRY

	if (!lpDrawItemStruct->itemData)
		return;
	CDC* odc = CDC::FromHandle(lpDrawItemStruct->hDC);
	BOOL bCtrlFocused = ((GetFocus() == this ) || (GetStyle() & LVS_SHOWSELALWAYS));
	odc->SetBkColor(GetBkColor());	//Cax2 - bkColor fix!
	CUpDownClient* client = (CUpDownClient*)lpDrawItemStruct->itemData;
	CMemDC dc(odc,&CRect(lpDrawItemStruct->rcItem));

	CFont *pOldFont = dc.SelectObject(GetFont());
	COLORREF crOldTextColor = dc->GetTextColor();
	COLORREF crOldBkColor = dc->GetBkColor();
	RECT cur_rec;
	#ifndef AMD
	memcpy(&cur_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));
	#else
	memcpy_amd(&cur_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));
	#endif

	CString Sbuffer;

	CKnownFile* file = theApp.sharedfiles->GetFileByID(client->reqfileid);
	CHeaderCtrl *pHeaderCtrl = GetHeaderCtrl();
	int iCount = pHeaderCtrl->GetItemCount();
	cur_rec.right = cur_rec.left - 8;
	cur_rec.left += 4;

	for(int iCurrent = 0; iCurrent < iCount; iCurrent++)
	{
		int iColumn = pHeaderCtrl->OrderToIndex(iCurrent);
		if(!IsColumnHidden(iColumn))
		{
			cur_rec.right += GetColumnWidth(iColumn);
			switch(iColumn)
			{
				case 0:
					{
					    POINT point = {cur_rec.left, cur_rec.top+1};
	
						// Display client icon
						switch(client->GetClientSoft()) {
							case SO_CDONKEY:
								imagelist.Draw(dc, 9, point, ILD_NORMAL);
								break;
							case SO_LMULE:
								imagelist.Draw(dc, 10, point, ILD_NORMAL);
								break;
							case SO_SHAREAZA:
								imagelist.Draw(dc, 11, point, ILD_NORMAL);
								break;
							case SO_EDONKEYHYBRID:
								imagelist.Draw(dc, 3, point, ILD_NORMAL);
								break;
							case SO_MLDONKEY:
								imagelist.Draw(dc, 2, point, ILD_NORMAL);
								break;
							case SO_EMULE:
							case SO_OLDEMULE:
								imagelist.Draw(dc, 1, point, ILD_NORMAL);
								break;
							case SO_EDONKEY:
								imagelist.Draw(dc, 0, point, ILD_NORMAL);
								break;
							default:
								imagelist.Draw(dc, 8, point, ILD_NORMAL);
								break;
						}

						// Display any Extra Overlay icons
						if (client->IsBanned())
							imagelist.Draw(dc, 6, point, ILD_TRANSPARENT);
						else if (client->IsFriend())
							imagelist.Draw(dc, 5, point, ILD_TRANSPARENT);
						else if (client->credits->GetScoreRatio() > 1)
							imagelist.Draw(dc, 4, point, ILD_TRANSPARENT);

						/*
	                    if(client->GetClientSoft() == SO_EDONKEYHYBRID) {
	                        imagelist.Draw(dc, 3, point, ILD_NORMAL);
	                        if (client->IsBanned())
	                            imagelist.Draw(dc, 6, point, ILD_TRANSPARENT);
	                        else if (client->IsFriend())
	                            imagelist.Draw(dc, 5, point, ILD_TRANSPARENT);
	                        else if (client->credits->GetScoreRatio() > 1)
	                            imagelist.Draw(dc, 4, point, ILD_TRANSPARENT);
	                    }
			            else if (client->GetClientSoft() == SO_MLDONKEY) {
	                        imagelist.Draw(dc, 2, point, ILD_NORMAL);
	                        if (client->IsBanned())
	                            imagelist.Draw(dc, 6, point, ILD_TRANSPARENT);
	                        else if (client->IsFriend())
	                            imagelist.Draw(dc, 5, point, ILD_TRANSPARENT);
	                        else if (client->credits->GetScoreRatio() > 1)
	                            imagelist.Draw(dc, 4, point, ILD_TRANSPARENT);
			            }
			            else if (client->GetClientSoft()==SO_EMULE || client->GetClientSoft()==SO_OLDEMULE) {
	                        imagelist.Draw(dc, 1, point, ILD_NORMAL);
	                        if (client->IsBanned())
	                            imagelist.Draw(dc, 6, point, ILD_TRANSPARENT);
	                        else if (client->IsFriend())
	                            imagelist.Draw(dc, 5, point, ILD_TRANSPARENT);
	                        else if (client->credits->GetScoreRatio() > 1)
	                            imagelist.Draw(dc, 4, point, ILD_TRANSPARENT);
	                    }
					    else {
	                        imagelist.Draw(dc, 0, point, ILD_NORMAL);
	                        if (client->IsBanned())
	                            imagelist.Draw(dc, 6, point, ILD_TRANSPARENT);
	                        else if (client->IsFriend())
	                            imagelist.Draw(dc, 5, point, ILD_TRANSPARENT);
	                        else if (client->credits->GetScoreRatio() > 1)
	                            imagelist.Draw(dc, 4, point, ILD_TRANSPARENT);
						}*/
	
	                    //if((client->GetClientSoft()==SO_EMULE) && (client->GetMuleVersion()==0x26)) {
	                    //    imagelist.Draw(dc, 7, point, ILD_TRANSPARENT);
	                    //}
	
	                    Sbuffer.Format(_T("%s"), client->GetUserName());
						cur_rec.left +=20;
						dc->DrawText(Sbuffer,Sbuffer.GetLength(),&cur_rec,DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX|DT_END_ELLIPSIS);
						cur_rec.left -=20;
						break;
	    			}
				case 1:
					if(file)
						Sbuffer.Format(_T("%s"), file->GetFileName());
					else
						Sbuffer = "?";
					break;
				case 2:
					Sbuffer.Format(_T("%.1f kB/s"),max((float)client->GetDatarate()/1024, 0.0));
					break;
				case 3:
					Sbuffer = CastItoXBytes(client->GetSessionUp());	
    				break;
				case 4:
					Sbuffer = CastSecondsToHM((client->GetWaitTime())/1000);
					break;
				case 5:
					Sbuffer = CastSecondsToHM((client->GetUpStartTimeDelay())/1000);
					break;
				case 6:
					Sbuffer	=	GetStatusULQueueString(client->GetUploadState());
					break;
				case 7:
                    {
						CString buffer;
                        uint32 partno = client->GetCurrentlyUploadingPart();
                        if(partno==0xFFFF)
                            buffer = "";
                        else
                            buffer.Format(_T(" (%d)"), partno);

					    if(client->GetUpPartCount())
					        Sbuffer.Format(_T("%d/%d%s"), client->GetAvailUpPartCount(), client->GetUpPartCount(), buffer);
                        else
					        Sbuffer.Format(_T("%s"), buffer);
                    }
                    break;
				case 8:
					if(client->GetUpPartCount() && theApp.glob_prefs->IsUploadPartsEnabled())		//Cax2 re-enabled toggle for progress bars
					{
						cur_rec.bottom--;
						cur_rec.top++;
						int iWidth = cur_rec.right - cur_rec.left;	
						int iHeight = cur_rec.bottom - cur_rec.top;
						client->DrawUpStatusBar(dc,&cur_rec,false,theApp.glob_prefs->UseFlatBar());
						cur_rec.bottom++;
						cur_rec.top--;
	
					}
					break;
				case 9:
	                float compress = client->GetCompression();
	                if (compress < 0.1f)
	                {						
    					Sbuffer.Format(_T("-"));
	                } else
    					Sbuffer.Format(_T("%.1f"),compress);
                    break;
			}
			if( iColumn != 8 && iColumn != 0 )
				dc->DrawText(Sbuffer,Sbuffer.GetLength(),&cur_rec,DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX|DT_END_ELLIPSIS);
			cur_rec.left += GetColumnWidth(iColumn);
		}
	}
	//draw rectangle around selected item(s)
	if ((lpDrawItemStruct->itemAction | ODA_SELECT) && (lpDrawItemStruct->itemState & ODS_SELECTED))
	{
		RECT outline_rec;
		#ifndef AMD
		memcpy(&outline_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));
		#else
		memcpy_amd(&outline_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));
		#endif

		outline_rec.top--;
		outline_rec.bottom++;
		dc->FrameRect(&outline_rec, &CBrush(GetBkColor()));
		outline_rec.top++;
		outline_rec.bottom--;
		outline_rec.left++;
		outline_rec.right--;

		if(bCtrlFocused)
			dc->FrameRect(&outline_rec, &CBrush(m_crFocusLine));
		else
			dc->FrameRect(&outline_rec, &CBrush(m_crNoFocusLine));
	}
	if ( pOldFont )
	{
		dc.SelectObject(pOldFont);
	}
	EMULE_CATCH
}

BEGIN_MESSAGE_MAP(CUploadListCtrl, CMuleListCtrl)
	ON_WM_CONTEXTMENU()
	ON_WM_ERASEBKGND() // added by FoRcHa
	//ON_WM_PAINT() // added by FoRcHa
	ON_NOTIFY_REFLECT(NM_CLICK, OnNMClick)
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnNMDblclkUploadlist)
	ON_WM_KEYUP()
	ON_WM_DRAWITEM()
END_MESSAGE_MAP()

// CUploadListCtrl message handlers
void CUploadListCtrl::OnContextMenu(CWnd* pWnd, CPoint point)
{	
	EMULE_TRY

//	POINT point;
//	::GetCursorPos(&point);	

	UINT flags=MF_STRING|MF_GRAYED;
	const CUpDownClient* client = NULL;
	if (GetSelectionMark() != -1)
	{
		if(GetSelectedCount()>0)
			flags=MF_STRING;
		if(client = (CUpDownClient*)GetItemData(GetSelectionMark()))
		{
			theApp.emuledlg->transferwnd.infolistctrl.SwitchToUser((CUpDownClient*)client);
			theApp.emuledlg->transferwnd.UpdateInfoHeader();
		}
	}

	if (m_ClientMenu) m_ClientMenu.DestroyMenu();
	m_ClientMenu.CreatePopupMenu();
	m_ClientMenu.AddMenuTitle(GetResString(IDS_CLIENTS));
	m_ClientMenu.AppendMenu(flags,MP_DETAIL, GetResString(IDS_SHOWDETAILS));
	if(client && client->IsFriend())
		m_ClientMenu.AppendMenu(flags,MP_REMOVEFRIEND, GetResString(IDS_REMOVEFRIEND));
	else
		m_ClientMenu.AppendMenu(flags,MP_ADDFRIEND, GetResString(IDS_ADDFRIEND));
	m_ClientMenu.AppendMenu(flags,MP_MESSAGE, GetResString(IDS_SEND_MSG));
	m_ClientMenu.AppendMenu(flags,MP_SHOWLIST, GetResString(IDS_VIEWFILES));
	m_ClientMenu.AppendMenu(MF_SEPARATOR);
	m_ClientMenu.AppendMenu(MF_STRING,MP_SWITCHCTRL, GetResString(IDS_SHOWQUEUE));
	SetMenu(&m_ClientMenu);
	m_ClientMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
//	*pResult = 0;
	m_ClientMenu.DestroyMenu();

	EMULE_CATCH
}

BOOL CUploadListCtrl::OnCommand(WPARAM wParam,LPARAM lParam ){
	EMULE_TRY

	if (GetSelectionMark() != (-1)){
		CUpDownClient* client = (CUpDownClient*)GetItemData(GetSelectionMark());
		switch (wParam){
			case MP_SHOWLIST:
				client->RequestSharedFileList();
				break;
			case MP_MESSAGE:
				theApp.emuledlg->chatwnd.StartSession(client);
				break;
			case MP_ADDFRIEND:
				theApp.friendlist->AddFriend(client);
				break;
			case MP_REMOVEFRIEND:
				theApp.friendlist->RemoveFriend(client);
				break;
			case MP_DETAIL:
				CClientDetailDialog dialog(client);
				dialog.DoModal();
				break;

		}
	}
	switch(wParam){
		case MP_SWITCHCTRL:
		{
			theApp.emuledlg->transferwnd.PostMessage(WM_COMMAND, USRMSG_SWITCHUPLOADLIST, (long)m_hWnd);
		}

	}

	EMULE_CATCH

	return true;
}


void CUploadListCtrl::OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult)
{
	EMULE_TRY

	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// if it's a second click on the same column then reverse the sort order,
	// otherwise sort the new column in ascending order.
	asc_sort[pNMListView->iSubItem] = !asc_sort[pNMListView->iSubItem];
	SetSortArrow(pNMListView->iSubItem, asc_sort[pNMListView->iSubItem]);
	SortItems(&SortProc,pNMListView->iSubItem+ ((asc_sort[pNMListView->iSubItem])? 0:10));
	*pResult = 0;
    theApp.glob_prefs->SetColumnSortItem(CPreferences::tableUpload, pNMListView->iSubItem);
    theApp.glob_prefs->SetColumnSortAscending(CPreferences::tableUpload, asc_sort[pNMListView->iSubItem]);

	EMULE_CATCH
}

int CUploadListCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	EMULE_TRY

	CUpDownClient* item1 = (CUpDownClient*)lParam1;
	CUpDownClient* item2 = (CUpDownClient*)lParam2;
	CKnownFile* file1 = theApp.sharedfiles->GetFileByID(item1->reqfileid);
	CKnownFile* file2 = theApp.sharedfiles->GetFileByID(item2->reqfileid);

	switch(lParamSort){
	case 0: 
		return CString(item1->GetUserName()).CompareNoCase(item2->GetUserName());
	case 10:
		return CString(item2->GetUserName()).CompareNoCase(item1->GetUserName());
	case 1: 
		if( (file1 != NULL) && (file2 != NULL))
			return CString(file1->GetFileName()).CompareNoCase(file2->GetFileName());
		else if( file1 == NULL )
			return 1;
		else
			return (file2 == NULL)?0:-1;
	case 11:
		if( (file1 != NULL) && (file2 != NULL))
			return CString(file2->GetFileName()).CompareNoCase(file1->GetFileName());
		else if( file1 == NULL )
			return 1;
		else
			return (file2 == NULL)?0:-1;
	case 2: 
			return (float)item1->GetDatarate() - (float)item2->GetDatarate();
	case 12:
			return (float)item2->GetDatarate() - (float)item1->GetDatarate();

	case 3:		//bugfixed 22/02
		return item1->GetSessionUp() - item2->GetSessionUp();
	case 13: 
		return item2->GetSessionUp() - item1->GetSessionUp();

	case 4: 
		return item1->GetWaitTime() - item2->GetWaitTime();
	case 14: 
		return item2->GetWaitTime() - item1->GetWaitTime();
	case 5: 
		return item1->GetUpStartTimeDelay() - item2->GetUpStartTimeDelay();
	case 15: 
		return item2->GetUpStartTimeDelay() - item1->GetUpStartTimeDelay();
	case 6: 
		return item1->GetUploadState() - item2->GetUploadState();
	case 16: 
		return item2->GetUploadState() - item1->GetUploadState();

    case 7:
    case 17:
    case 8:
    case 18:
            {  // obaldin: sort by upload progress
                int res;
                uint32 partcnt1 = item1->GetUpPartCount();
                uint32 partcnt2 = item2->GetUpPartCount();
                if( (partcnt1==0) && (partcnt2==0))
                    res=0;
                else if(partcnt1==0)
                    res = -1;
                else if(partcnt2==0)
                    res = 1;
                else {
                    float progr1 = float(item1->GetAvailUpPartCount())/float(partcnt1);
                    float progr2 = float(item2->GetAvailUpPartCount())/float(partcnt2);
                    if(progr1<progr2)
                        res = -1;
                    else if(progr1>progr2)
                        res = 1;
                    else 
                        res = 0;
                }

                if(lParamSort<10)
                    return res;
                else 
                    return -res;
            }

	case 9: // Add sort compression
		return (item1->GetCompression() < item2->GetCompression())?-1:1;
	case 19: // Add sort compression
		return (item2->GetCompression() < item1->GetCompression())?-1:1;
	}
	EMULE_CATCH

	return 0;
}


// added by FoRcHa: //////////////////////////////////
BOOL CUploadListCtrl::OnEraseBkgnd(CDC* pDC)
{
	return CListCtrl::OnEraseBkgnd(pDC);
}

void CUploadListCtrl::OnPaint()
{
	EMULE_TRY

	CPaintDC dc(this);
    
	CRect headerRect;
	GetDlgItem(0)->GetWindowRect(&headerRect);
	ScreenToClient(&headerRect);
	dc.ExcludeClipRect(&headerRect);
			
	CMemDC2 memDC(&dc);

    CRect clip;
    memDC.GetClipBox(&clip);
    memDC.FillSolidRect(clip, GetSysColor(COLOR_WINDOW));
	
	DefWindowProc(WM_PAINT, (WPARAM)memDC->m_hDC, (LPARAM)0); // causes resource memory leak


	EMULE_CATCH
}

void CUploadListCtrl::OnNMClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY

	RefreshInfo();	
	*pResult = 0;

	EMULE_CATCH
}

void CUploadListCtrl::OnNMDblclkUploadlist(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY

	if (GetSelectionMark() != (-1))
	{
		CUpDownClient* client = (CUpDownClient*)GetItemData(GetSelectionMark());
		if (theApp.glob_prefs->GetDetailsOnClick())
		{
			CClientDetailDialog dialog(client);
			dialog.DoModal();
		} else {
			theApp.emuledlg->chatwnd.StartSession(client);
		}
	}
	*pResult = 0;

	EMULE_CATCH
}

void CUploadListCtrl::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	EMULE_TRY

	RefreshInfo();
	CMuleListCtrl::OnKeyUp(nChar, nRepCnt, nFlags);

	EMULE_CATCH
}

void CUploadListCtrl::RefreshInfo(void)
{
	EMULE_TRY

	POSITION pos = GetFirstSelectedItemPosition();
	if(pos == NULL)
	{			
		theApp.emuledlg->transferwnd.infolistctrl.SwitchToFile(NULL);
		theApp.emuledlg->transferwnd.UpdateInfoHeader();
	}
	else
	{
		const CUpDownClient* client = (CUpDownClient*)GetItemData(GetSelectionMark());
		theApp.emuledlg->transferwnd.infolistctrl.SwitchToUser((CUpDownClient*)client);
		theApp.emuledlg->transferwnd.UpdateInfoHeader();
	}	

	EMULE_CATCH
}

BOOL CUploadListCtrl::OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult)
{
	if(message != WM_DRAWITEM) {
		//catch the prepaint and copy struct
		if(message == WM_NOTIFY && ((NMHDR*)lParam)->code == NM_CUSTOMDRAW &&
		  ((LPNMLVCUSTOMDRAW)lParam)->nmcd.dwDrawStage == CDDS_ITEMPREPAINT) {

			m_bCustomDraw = CListCtrl::OnChildNotify(message, wParam, lParam, pLResult);
			if(m_bCustomDraw)
				#ifndef AMD
				memcpy(&m_lvcd, (void*)lParam, sizeof(NMLVCUSTOMDRAW));
				#else
				memcpy_amd(&m_lvcd, (void*)lParam, sizeof(NMLVCUSTOMDRAW));
				#endif
			return m_bCustomDraw;
		}

		return CListCtrl::OnChildNotify(message, wParam, lParam, pLResult);
	}
	ASSERT(pLResult == NULL); // no return value expected
	UNUSED(pLResult);         // unused in release builds

	DrawItem((LPDRAWITEMSTRUCT)lParam);
	return TRUE;
}
